// EPCSDK.cpp : Defines the entry point for the DLL application.
//
#include <string.h>
#include "EPCSDK.h"
#include "CommSerial.h"

#define	LEN_Tag							(12)
#define LEN_TagEPCData			(8)
#define SIZE_COMMBuffer			(1024 * 4)

static char buffer[SIZE_COMMBuffer];

HANDLE  OpenComm(int portNo)
{
	return ::COMMOpen(portNo);
}

void  CloseComm(HANDLE hCom)
{
	::COMMClose(hCom);
}

bool  ReadFirmwareVersion(HANDLE hCom, int* main, int* sub,char ReaderAddr)
{
	bool ret = false;
	buffer[0] = 0xA0;
	buffer[1] = 0x03;
	buffer[2] = 0x6A;
    buffer[3] = ReaderAddr;
	buffer[4] = ::GetCheckSum(buffer, 4); //ӻأE0 05 6Aͷ00usercode 03 56 汾ţ58checksum  
	::COMMPurgeComm(hCom);
	if(::COMMSendData(hCom, (const char*)buffer, 5) == 5)
	{
		::memset(buffer, 0, 7 * sizeof(char));
		if(::COMMReceiveData(hCom, (char*)buffer, 7) == 7)
		{
			if(	   buffer[0] == 0xE0 
				&& buffer[1] == 0x05 
				&& buffer[2] == 0x6A 
				&& buffer[6] == ::GetCheckSum(buffer, 6)	)
				*main = buffer[4];
				*sub = buffer[5];
				ret = true;
		}
	}
	return ret;
}

//A0 06 63 00 05 00 20 D2 Ʒʶѯ
//ӻأ(E0 0B 63) ͷ( 00) usercode 05 00 20 (38 32 32 30 FF) ֵ (C2) checksum

bool  GetReaderParameters(HANDLE hCom, int addr, int paramNum, char* params,char ReaderAddr)
{
	bool ret = false;
	buffer[0] = 0xA0;
	buffer[1] = 0x06;
	buffer[2] = 0x63;
	buffer[3] = ReaderAddr; //<xxm 110715
	buffer[4] = (unsigned char)paramNum;
	buffer[5] = 0x00;
	buffer[6] = (unsigned char)addr;
	buffer[7] = GetCheckSum(buffer, 7);
	::COMMPurgeComm(hCom);
	if(::COMMSendData(hCom, (const char*)buffer, 8) == 8)
	{
		int correctRecvNum = 6 + paramNum + 2;
		::memset(buffer, 0, correctRecvNum * sizeof(unsigned char));
		if(::COMMReceiveData(hCom, (char*)buffer, correctRecvNum) == correctRecvNum)
		{
			if(	   buffer[0] == 0xE0 
				&& buffer[1] == (unsigned char)(correctRecvNum - 2) 
				&& buffer[2] == 0x63 
				&& buffer[4] == (unsigned char)paramNum 
				&& buffer[5] == 0x00 
				&& buffer[6] == (unsigned char)addr 
				&& buffer[correctRecvNum - 1] == GetCheckSum(buffer, correctRecvNum - 1)	)
				
				for(int i = 0; i < paramNum; i++)
					params[i] = buffer[i + 6];
				ret = true;
		}
	}
	return ret;
}

//磺A0 0E 62 00 08 00 92 01 04 10 40 00 01 02 01 FD (Ƶ)
//ӻأE4 04 62 00 usercode00 statusB6Checksum    
bool  SetReaderParameters(HANDLE hCom, int addr, int paramNum, const char* params,char ReaderAddr)
{
	bool ret = false;
	int sendNum = paramNum + 8;
	buffer[0] = 0xA0;
	buffer[1] = (char)(sendNum - 2);
	buffer[2] = 0x62;
    buffer[3] = ReaderAddr;				//usercode
	buffer[4] = (char)paramNum;
	buffer[5] = 0x00;
	buffer[6] = (char)addr;

	for(int i = 0; i < paramNum; i++)
		buffer[7 + i] = params[i];

	buffer[sendNum - 1] = GetCheckSum(buffer, sendNum - 1);
	::COMMPurgeComm(hCom);
	if(::COMMSendData(hCom, (const char*)buffer, sendNum) == sendNum)
	{
		::memset(buffer, 0, 6 * sizeof(char));
		if(::COMMReceiveData(hCom, (char*)buffer, 6) == 6)
		{
			if(	   buffer[0] == 0xE4 
				&& buffer[1] == 0x04 
				&& buffer[2] == 0x62 
				&& buffer[4] == 0x00  
				&& buffer[5] == GetCheckSum(buffer, 5)	)
				ret = true;
		}
	}
	return ret;
}
// A0 03 A8 00 B5
//ӻأ       E0  04  A8  usercode  status  checksum
bool  StopReading(HANDLE hCom,char ReaderAddr)
{
	bool ret = false;
	buffer[0] = 0xA0;
	buffer[1] = 0x03;
	buffer[2] = 0xA8; 
    buffer[3] = ReaderAddr; 
	buffer[4] = ::GetCheckSum(buffer, 4);
	::COMMPurgeComm(hCom);
	if(::COMMSendData(hCom, (const char*)buffer, 5) == 5)
	{
		::memset(buffer, 0, 6 * sizeof(char));
		if(::COMMReceiveData(hCom, (char*)buffer, 6) == 6)
		{
			if(	   buffer[0] == 0xE0 
                && buffer[1] == 0x04 
				&& buffer[2] == 0xA8
				&& buffer[4] == 0x00 		
				&& buffer[5] == ::GetCheckSum(buffer, 5)	)
				ret = true;
		}
	}
	return ret;
}

//A0 03 65 00 F8
//ӻأE4  04  65  usercode  status  checksum
bool  ResumeReading(HANDLE hCom,char ReaderAddr)
{
	bool ret = false;
	buffer[0] = 0xA0;
	buffer[1] = 0x03;
	buffer[2] = 0x65;
    buffer[3] = ReaderAddr;
	buffer[4] = ::GetCheckSum(buffer, 4);
	::COMMPurgeComm(hCom);
	if(::COMMSendData(hCom, (const char*)buffer, 5) == 5)
	{
		::memset(buffer, 0, 6 * sizeof(char));
		if(::COMMReceiveData(hCom, (char*)buffer, 6) == 6)
		{
			if(	   buffer[0] == 0xE4 
				&& buffer[1] == 0x04 
				&& buffer[2] == 0x65 
				&& buffer[5] == ::GetCheckSum(buffer, 5)	)
				if(buffer[4] == 0x00)
					ret = true;
		}
	}
	return ret;
}

// A0 03 82 00 DB         
//ӻأ   E0 10 82 00 01 FF FF 11 22 33 44 55 66 77 88 00 0B 20 
bool  IdentifySingleTag(HANDLE hCom, char* tagID, char* antennaNo,char ReaderAddr)
{
	bool ret = false;
	antennaNo=0;
	buffer[0] = 0xA0;
	buffer[1] = 0x03;
	buffer[2] = 0x82;
	buffer[3] = ReaderAddr; 
	buffer[4] = ::GetCheckSum(buffer, 4);
	::COMMPurgeComm(hCom);
	if(::COMMSendData(hCom, (const char*)buffer, 5) == 5)
	{
		::memset(buffer, 0, 18 * sizeof(char));
		if(::COMMReceiveData(hCom, (char*)buffer, 18) == 18)
		{
			if(	   buffer[0] == 0xE0 
				&& buffer[1] == 0x10 
				&& buffer[2] == 0x82 
				&& buffer[17] == ::GetCheckSum(buffer, 17)	)
				::memcpy(tagID, &buffer[5], LEN_Tag);
				if(antennaNo != 0)
					*antennaNo = buffer[4];
				ret = true;
		}
	}
	return ret;
}

bool  IdentifyUploadedSingleTag(HANDLE hCom, char* tagID, char* devNo, char* antennaNo)
{
	bool ret = false;
	::memset(buffer, 0, LEN_Tag * sizeof(char));
	if(::COMMReceiveData(hCom, (char*)buffer, 17) == 17)
	{
		if(	   buffer[0] == 0x00 
			&& buffer[15] == ::GetCheckSum(buffer, 15)	
			&& buffer[16] == 0xFF )
		{
			::memcpy(tagID, &buffer[2], LEN_Tag);
			if(devNo != 0)
				*devNo = buffer[1];
			if(antennaNo != 0)
				*antennaNo = buffer[14];
			ret = true;
		}
	}
	return ret;
}

bool  IdentifyUploadedMultiTags(HANDLE hCom, char* tagNum, char* tagIDs, char* devNos, char* antennaNos)
{
	bool ret = false;
	::memset(buffer, 0, LEN_Tag * sizeof(char));
//	int recvNum = ::COMMReceiveData(hCom, (char*)buffer, 17 * 200);
	int recvNum = ::COMMReceiveData(hCom, (char*)buffer, 17 * 50);
	if(recvNum >= 17)
	{
		*tagNum = 0;
		int i = 0;
		while(i + 17 - 1 < recvNum)
		{
			if(	   buffer[i] == 0x00 
				&& buffer[i + 15] == ::GetCheckSum(&buffer[i], 15)	
				&& buffer[i + 16] == 0xFF )
			{
				::memcpy(&tagIDs[(*tagNum) * 12], &buffer[i + 2], LEN_Tag);
				if(devNos != 0)
					devNos[*tagNum] = buffer[i + 1];
				if(antennaNos != 0)
					antennaNos[*tagNum] = buffer[i + 14];
				(*tagNum) += 1;
				i += 17;
			}
			else
				i += 1;
		}
		ret = true;
	}
	return ret;
}

//ͣ A0 06 80 00 01 02 01 D6; 0x02ַʼ𣬶ȡ1ֵݡ
//ӻأ   E0 08 80 00 01 02 01 55 55 EA 
bool  ReadTag(HANDLE hCom, char memBank, char address, char length, char* data,char ReaderAddr)
{
	bool ret = false;
	buffer[0] = 0xA0;
	buffer[1] = 0x06;
	buffer[2] = 0x80;
	buffer[3] = ReaderAddr;
	buffer[4] = memBank;
	buffer[5] = address;
	buffer[6] = length;
	buffer[7] = ::GetCheckSum(buffer, 7);
	::COMMPurgeComm(hCom);
	if(::COMMSendData(hCom, (const char*)buffer, 8) == 8)
	{
		int expectedRecvLen = length * 2 + 8;
		::memset(buffer, 0, expectedRecvLen * sizeof(char));
		if(::COMMReceiveData(hCom, (char*)buffer, expectedRecvLen) == expectedRecvLen)
		{
			if(	   buffer[0] == 0xE0 
				&& buffer[2] == 0x80 
//				&& buffer[3] == 0x04 
				&& buffer[expectedRecvLen - 1] == ::GetCheckSum(buffer, expectedRecvLen - 1)	)
				::memcpy(data, &buffer[7], length * 2);
				ret = true;
		}
	}
	return ret;
}
//:A0 09 81 00 00 01 02 01 12 34 8C
//ӻأ E0 04 81  usercode  status  checksum    

bool  WriteTagSingleWord(HANDLE hCom, char memBank, char address, char data1, char data2,char ReaderAddr)
{
	bool ret = false;
	buffer[0] = 0xA0;
	buffer[1] = 0x09;
	buffer[2] = 0x81;
	buffer[3] = ReaderAddr;
	buffer[4] = 0x00;
	buffer[5] = memBank;
	buffer[6] = address;
	buffer[7] = 0x01;
	buffer[8] = data1;
	buffer[9] = data2;
	buffer[10] = ::GetCheckSum(buffer, 10);
	::COMMPurgeComm(hCom);
/*
	if(::COMMSendData(hCom, (const char*)buffer, 11) == 11)
	{
		::memset(buffer, 0, 16 * sizeof(char));
		if(::COMMReceiveData(hCom, (char*)buffer, 16) == 16)
		{
			if(	   buffer[0] == 0xE0 
				&& buffer[1] == 0x0E 
				&& buffer[2] == 0x81 
				&& buffer[3] == 0x02 
				&& buffer[14] == 0x00 
				&& buffer[15] == ::GetCheckSum(buffer, 15)	)
				ret = true;
		}
	}
*/
   if(::COMMSendData(hCom, (const char*)buffer, 11) == 11)
	{
		::memset(buffer, 0, 6 * sizeof(char));
		if(::COMMReceiveData(hCom, (char*)buffer, 6) == 6)
		{
			if(	   buffer[0] == 0xE0 
				&& buffer[1] == 0x04 
				&& buffer[2] == 0x81 
				&& buffer[4] == 0x00 			
				&& buffer[5] == ::GetCheckSum(buffer, 5)	)
				ret = true;
		}
	}
	return ret;
}

//A0 0B 81 00 01 01 02 02 55 55 AA AA D0
//ӻأE0  04  81  usercode  status  checksum      
bool  WriteTagMultiWord(HANDLE hCom, char memBank, char address, char WordCount,const char* chars,char ReaderAddr)
{
	char  i;
	bool ret = false;
	buffer[0] = 0xA0;
	buffer[1] = 0x09;
	buffer[2] = 0x81;
	buffer[3] = ReaderAddr;//user code
	buffer[4] = 0x01;
	buffer[5] = memBank;
	buffer[6] = address;
	buffer[7] = WordCount;
	for(i=0;i<(WordCount*2);i++)
	{
	 buffer[8+i] = chars[i];
	}
	buffer[8+WordCount*2] = ::GetCheckSum(buffer,(8+WordCount*2));
	::COMMPurgeComm(hCom);

   if(::COMMSendData(hCom, (const char*)buffer, (9+WordCount*2)) == (9+WordCount*2))
	{
		::memset(buffer, 0, 6 * sizeof(char));
		if(::COMMReceiveData(hCom, (char*)buffer, 6) == 6)
		{
			if(	   buffer[0] == 0xE0 
				&& buffer[1] == 0x04 
				&& buffer[2] == 0x81 
				&& buffer[4] == 0x00 			
				&& buffer[5] == ::GetCheckSum(buffer, 5)	)
				ret = true;
		}
	}
	return ret;
}
//<xxm 110720
//a0 XX AB  memtype startaddr wordlength d0 d1 d2 d3 d4 d5 d6 d7 checksum 
bool  FastWriteTag(HANDLE hCom, char memBank, char address, char WordCount,const char* chars,char ReaderAddr)
{
	char	minAddr;
	char	maxAddr;
	char	minLen;
	char	maxLen;
	char	maxSum;

	char  i;
	bool ret = false;
	buffer[0] = 0xA0;
	buffer[1] = 0x6+WordCount*2;
	buffer[2] = 0xAB;
	buffer[3] = ReaderAddr;
	buffer[4] = memBank;
	buffer[5] = address;
	buffer[6] = WordCount;
    
	if(memBank==1)			//epc
	{
		minAddr = 2;
		maxAddr = 7;
		minLen = 1;
		maxLen = 6;
		maxSum = 8;
	}
    else if(memBank==3)		//user
    {
        minAddr = 0;
		maxAddr = 31;
		minLen = 1;
		maxLen = 8;
		maxSum = 32;
	}
	else if(memBank==2)		//tid
	{
       return ret;
	}
	else                    //reserve
	{
        minAddr = 0;
		maxAddr = 3;
		minLen = 1;
		maxLen = 4;
		maxSum = 4;
	}

	if(address > maxAddr || address < minAddr)
		return ret;
	else if(WordCount > maxLen || WordCount < minLen)		
		return ret;
	else if(address + WordCount > maxSum)
		return ret;

	for(i=0;i<(WordCount*2);i++)
	{
	 buffer[7+i] = chars[i];
	}
	buffer[7+WordCount*2] = ::GetCheckSum(buffer,(7+WordCount*2));
	::COMMPurgeComm(hCom);

   if(::COMMSendData(hCom, (const char*)buffer, (8+WordCount*2)) == (8+WordCount*2))
	{
		::memset(buffer, 0, 6 * sizeof(char));
		if(::COMMReceiveData(hCom, (char*)buffer, 6) == 6)
		{
			if(	   buffer[0] == 0xE0 
				&& buffer[1] == 0x04 
				&& buffer[2] == 0xAB 
				&& buffer[4] == 0x00 			
				&& buffer[5] == ::GetCheckSum(buffer, 5)	)
				ret = true;
		}
	}
	return ret;
}
//<xxm 110720

//--------------------------------------------------------------------------------------------------
//<xxm 110429 

 //A0 0F AA 00 D1 D2 D3 D4 D5 D6 D7 D8 D9 D10 D11 D12 CHECKSUM
 //D1-D12 ָEPC IDţ12ֽڡ
//E0 0B AA 00 TID1 TID2  TID3  TID4  TID5  TID6  TID7  TID8 CHECKSUM
//            TID1-TID8 ΪָEPC TID8ֽڡ
//E4 04 AA 00 STATUS CEHCKSUM 

bool  ReadTIDByEpcID(HANDLE hCom, const char* chars,char* data,char ReaderAddr)
{
	char  i;
	bool ret = false;
	buffer[0] = 0xA0;
	buffer[1] = 0x0F;
	buffer[2] = 0xAA;
    buffer[3] = ReaderAddr;
	for(i=0;i<12;i++)
	{
	 buffer[4+i] = chars[i];
	}

	buffer[16] = ::GetCheckSum(buffer,16);
	::COMMPurgeComm(hCom);

   if(::COMMSendData(hCom, (const char*)buffer, 17) == 17)
	{
		::memset(buffer, 0, 13 * sizeof(char));
		if(::COMMReceiveData(hCom, (char*)buffer,13) ==13)
		{
			if(	   buffer[0] == 0xE0 
				&& buffer[1] == 0x0B 
				&& buffer[2] == 0xAA 
				&& buffer[4] == 0x00 			
				&& buffer[12] == ::GetCheckSum(buffer, 12)	)
			{
				::memcpy(data, &buffer[4], 8);
				ret = true;
			}
		}
	}
	return ret;
}

//A0 0xx AC membank address  wordLength d0,d1,---d11,CHECKSUM 
//A0 11  AC 02 02 04 12 34 56 78 99 99 11 11 00 11 22 33 CD 
//<xxm 110721
bool  ReadByEpcID(HANDLE hCom, char memBank, char address, char WordCount,const char* EpcID, char* data,char ReaderAddr)
{
	char  i;
	bool ret = false;
	buffer[0] = 0xA0;
	buffer[1] = 18;
	buffer[2] = 0xAC;
	buffer[3] = ReaderAddr;
    buffer[4] = memBank;
	buffer[5] = address;
	buffer[6] = WordCount;

	for(i=0;i<12;i++)
	{
	 buffer[7+i] = EpcID[i];
	}

    buffer[19] = ::GetCheckSum(buffer,19);
    ::COMMPurgeComm(hCom);

   if(::COMMSendData(hCom, (const char*)buffer, 20) == 20)
	{
		::memset(buffer, 0, (6+2*WordCount) * sizeof(char));
		if(::COMMReceiveData(hCom, (char*)buffer,(6+2*WordCount)) ==(6+2*WordCount))
		{
			if(	   buffer[0] == 0xE0 
				&& buffer[1] == (4+2*WordCount)
				&& buffer[2] == 0xAC 
				&& buffer[4] == 0x00 			
				&& buffer[5+2*WordCount]== ::GetCheckSum(buffer, (5+2*WordCount))	)
			{
				::memcpy(data, &buffer[5], 2*WordCount);
				ret = true;
			}
		}
	}
	return ret;
}
//<xxm 110721
//A0 0xx AC membank address  wordLength d0,d1,data ---d11,CHECKSUM 
//A0 11  AC 02 02 04 12 34 56 78 99 99 11 11 00 11 22 33 CD 
//<xxm 110722
bool  WriteByEpcID(HANDLE hCom, char memBank, char address, char WordCount,const char* EpcID,char* data,char ReaderAddr)
{
	char  i;
	bool ret = false;
	buffer[0] = 0xA0;
	buffer[1] = 18+2*WordCount;
	buffer[2] = 0xAD;
	buffer[3] = ReaderAddr;
    buffer[4] = memBank;
	buffer[5] = address;
	buffer[6] = WordCount;
	for(i=0;i<(12+2*WordCount);i++)
	{
	 buffer[7+i] = EpcID[i];
	}

    buffer[19+2*WordCount] = ::GetCheckSum(buffer,(19+2*WordCount));
    ::COMMPurgeComm(hCom);

   if(::COMMSendData(hCom, (const char*)buffer, (20+2*WordCount)) == (20+2*WordCount))
	{
		::memset(buffer, 0, 6 * sizeof(char));
		if(::COMMReceiveData(hCom, (char*)buffer,6) ==6)
		{
			if(	   buffer[0] == 0xE4 
				&& buffer[1] == 4
				&& buffer[2] == 0xAD 
				&& buffer[4] == 0x00 			
				&& buffer[5]== ::GetCheckSum(buffer,5)	)
			{				
				ret = true;
			}
		}
	}
	return ret;
}
//<xxm 110722
//---------------------------------------------------------------------------------
bool  FastWriteTagID(HANDLE hCom, int charsNum, const char* chars,char ReaderAddr)
{
	bool ret = false;
	if(charsNum > 0 && (charsNum % 2) == 0 && chars != 0)
	{
		buffer[0] = 0xA0;
		buffer[1] = 4 + charsNum;
		buffer[2] = 0x9C;
        buffer[3] = ReaderAddr;
		buffer[4] = charsNum / 2;
		for(int i = 0; i < charsNum; i++)
			buffer[5 + i] = chars[i];
		buffer[5 + charsNum] = GetCheckSum(buffer, 5 + charsNum);
		::COMMPurgeComm(hCom);
		if(::COMMSendData(hCom, (const char*)buffer, 6 + charsNum) == 6 + charsNum)
		{
			::memset(buffer, 0, 6 * sizeof(char));
			if(::COMMReceiveData(hCom, (char*)buffer, 6) == 6)
			{
				if(	   buffer[0] == 0xE0 
					&& buffer[1] == 0x04 
					&& buffer[2] == 0x9C 
					&& buffer[4] == 0x00 
					&& buffer[5] == GetCheckSum(buffer, 5)	)
					ret = true;
			}
		}
	}
	return ret;
}

bool  FastWriteTagID_Lock(HANDLE hCom, int charsNum, const char* chars,char ReaderAddr)
{
	bool ret = false;
	if(charsNum > 0 && (charsNum % 2) == 0 && chars != 0)
	{
		buffer[0] = 0xA0;
		buffer[1] = 3 + charsNum;
		buffer[2] = 0x9F;
		buffer[3] = charsNum / 2;
		for(int i = 0; i < charsNum; i++)
			buffer[4 + i] = chars[i];
		buffer[4 + charsNum] = GetCheckSum(buffer, 4 + charsNum);
		::COMMPurgeComm(hCom);
		if(::COMMSendData(hCom, (const char*)buffer, 5 + charsNum) == 5 + charsNum)
		{
			::memset(buffer, 0, 5 * sizeof(char));
			if(::COMMReceiveData(hCom, (char*)buffer, 5) == 5)
			{
				if(	   buffer[0] == 0xE0 
					&& buffer[1] == 0x03 
					&& buffer[2] == 0x9F 
					&& buffer[3] == 0x00 
					&& buffer[4] == GetCheckSum(buffer, 4)	)
					ret = true;
			}
		}
	}
	return ret;
}

//A0 03 99 00 C4
//ӻأE4  04  99  usercode  status checksum  
bool  InitializeTag(HANDLE hCom,char ReaderAddr)
{
	bool ret = false;
	buffer[0] = 0xA0;
	buffer[1] = 0x03;
	buffer[2] = 0x99;
	buffer[3] = ReaderAddr;
	buffer[4] = ::GetCheckSum(buffer, 4);
	::COMMPurgeComm(hCom);
	if(::COMMSendData(hCom, (const char*)buffer, 5) == 5)
	{
		::memset(buffer, 0, 6 * sizeof(char));
		if(::COMMReceiveData(hCom, (char*)buffer, 6) == 6)
		{
			if(	   buffer[0] == 0xE4 
				&& buffer[1] == 0x04 
				&& buffer[2] == 0x99 
				&& buffer[4] == 0x00 
				&& buffer[5] == ::GetCheckSum(buffer, 5)	)
				ret = true;
		}
	}
	return ret;
}
/*
bool LockTag(HANDLE hCom, char lockType,char ReaderAddr)
{
	bool ret = false;
	buffer[0] = 0xA0;
	buffer[1] = 0x04;
	buffer[2] = 0x87;
	buffer[3] = 0x04;
	buffer[4] = lockType;
	buffer[5] = ::GetCheckSum(buffer, 5);
	::COMMPurgeComm(hCom);
	if(::COMMSendData(hCom, (const char*)buffer, 6) == 6)
	{
		::memset(buffer, 0, 5 * sizeof(char));
		if(::COMMReceiveData(hCom, (char*)buffer, 5) == 5)
		{
			if(	   buffer[0] == 0xE4 
				&& buffer[1] == 0x03 
				&& buffer[2] == 0x87 
				&& buffer[3] == 0x00 
				&& buffer[4] == ::GetCheckSum(buffer, 4)	)
				ret = true;
		}
	}
	return ret;
}*/
//<xxm 110319

//A0 08 A5 00 12 34 56 78 03 9C
//ӻأ E4  04  A5  usercode  status  checksum
bool  LockPassWordTag(HANDLE hCom,char passwd1,char passwd2,char passwd3,char passwd4,char lockType,char ReaderAddr)
{
	bool ret = false;
	buffer[0] = 0xA0;
	buffer[1] = 0x08;
	buffer[2] = 0xA5;
	buffer[3] = ReaderAddr;
    buffer[4] = passwd1;
    buffer[5] = passwd2;
    buffer[6] = passwd3;
	buffer[7] = passwd4;
	buffer[8] = lockType;
	buffer[9] = ::GetCheckSum(buffer, 9);
	::COMMPurgeComm(hCom);
	if(::COMMSendData(hCom, (const char*)buffer, 10) == 10)
	{
		::memset(buffer, 0, 6 * sizeof(char));
		if(::COMMReceiveData(hCom, (char*)buffer, 6) == 6)
		{
			if(	   buffer[0] == 0xE4 
				&& buffer[1] == 0x04 
				&& buffer[2] == 0xA5 
				&& buffer[4] == 0x00 
				&& buffer[5] == ::GetCheckSum(buffer, 5)	)
				ret = true;
		}
	}
	return ret;
}
//<xxm 110319
bool  UnlockPassWordTag(HANDLE hCom,char passwd1,char passwd2,char passwd3,char passwd4,char lockType,char ReaderAddr)
{
	bool ret = false;
	buffer[0] = 0xA0;
	buffer[1] = 0x08;
	buffer[2] = 0xA6;
    buffer[3] = ReaderAddr;
    buffer[4] = passwd1;
    buffer[5] = passwd2;
    buffer[6] = passwd3;
	buffer[7] = passwd4;
	buffer[8] = lockType;
	buffer[9] = ::GetCheckSum(buffer, 9);
	::COMMPurgeComm(hCom);
	if(::COMMSendData(hCom, (const char*)buffer, 10) == 10)
	{
		::memset(buffer, 0, 6 * sizeof(char));
		if(::COMMReceiveData(hCom, (char*)buffer, 6) == 6)
		{
			if(	   buffer[0] == 0xE4 
				&& buffer[1] == 0x04 
				&& buffer[2] == 0xA6 
				&& buffer[4] == 0x00 
				&& buffer[5] == ::GetCheckSum(buffer, 5)	)
				ret = true;
		}
	}
	return ret;
}
//<xxm 110319

//A0 08 86 00 00 12 34 56 78 BE
//ӻأE4 04 86 status usercode checksum 
bool  KillTag(HANDLE hCom, char passwd1, char passwd2, char passwd3, char passwd4,char ReaderAddr)
{
	bool ret = false;
	buffer[0] = 0xA0;
	buffer[1] = 0x08;
	buffer[2] = 0x86;
	buffer[3] = ReaderAddr;
	buffer[4] = 0x00;
	buffer[5] = passwd1;
	buffer[6] = passwd2;
	buffer[7] = passwd3;
	buffer[8] = passwd4;
	buffer[9] = ::GetCheckSum(buffer, 9);
	::COMMPurgeComm(hCom);
	if(::COMMSendData(hCom, (const char*)buffer, 10) == 10)
	{
		::memset(buffer, 0, 6 * sizeof(char));
		if(::COMMReceiveData(hCom, (char*)buffer, 6) == 6)
		{
			if(	   buffer[0] == 0xE4 
				&& buffer[1] == 0x04 
				&& buffer[2] == 0x86 
				&& buffer[4] == 0x00 
				&& buffer[5] == ::GetCheckSum(buffer, 5)	)
				ret = true;
		}
	}
	return ret;
}
